
var $q = angular.element(vitisApp.appMainDrtv).injector().get(['$q']);
var $log = angular.element(vitisApp.appMainDrtv).injector().get(['$log']);
var envSrvc = angular.element(vitisApp.appMainDrtv).injector().get(['envSrvc']);
var propertiesSrvc = angular.element(vitisApp.appMainDrtv).injector().get(['propertiesSrvc']);

/**
 * constructor_form
 * Function called by form init only if javascript boolean is Equal true
 * @param {type} scope Scope who contain the formreader
 * @param {type} s_url URL of file for destructor
 * @returns {undefined}
 */
var constructor_form = function (scope, s_url) {
    console.log("Constructor Rapports");

    var sBoId;
    console.log("propertiesSrvc: ", propertiesSrvc);
    if (angular.isDefined(propertiesSrvc)) {
        if (angular.isDefined(propertiesSrvc['anc'])) {
            if (angular.isDefined(propertiesSrvc['anc']['controle'])) {
                if (angular.isDefined(propertiesSrvc['anc']['controle']['business_object_id'])) {
                    sBoId = propertiesSrvc['anc']['controle']['business_object_id'];
                }
            }
        }
    }

    getReportsArray(sBoId).then(function(aPrintReports){
        console.log("aPrintReports: ", aPrintReports);

        if (typeof aPrintReports !== 'object') {
            aPrintReports = [];
        }

        var sHTMLList = getReportsListAsHTML(aPrintReports);
        $('#anc_saisie_controle_rapports_list_container').parent().html(sHTMLList);
    });
};

/**
 * destructor_form
 * Function called before constructor_form of a new form to remove all the watchers, variables, and others objects useless for others forms
 * @returns {undefined}
 */
var destructor_form = function () {
    console.log("Destructor Rapports");
};

/**
 * Download the BO reports list
 * @param  {string} business_object_id
 * @return {promise}
 */
var getReportsArray = function(sBoId) {
    $log.info('getReportsArray');

    var deferred = $q.defer();

    if (!angular.isDefined(sBoId) || sBoId == '') {
        console.error('Objet métier non configuré');
        deferred.resolve([]);
    } else {

        // Récupère la liste des rapports disponibles
        ajaxRequest({
            'method': 'GET',
            'url': propertiesSrvc["web_server_name"] + "/" + propertiesSrvc["services_alias"] + '/vmap/printreports',
            'headers': {
                'Accept': 'application/x-vm-json'
            },
            'params': {
                'attributs': 'name|printreport_id|business_object_id|business_object_id_field|multiobject',
                'filter': {
                    "column": "business_object_id",
                    "compare_operator": "=",
                    "value": sBoId
                }
            },
            'success': function (response) {
                if (!angular.isDefined(response['data'])) {
                    console.error('response.data undefined: ', response);
                    deferred.resolve([]);
                    return 0;
                }
                if (!angular.isDefined(response['data']['data'])) {
                    console.error('Aucun rapport disponible pour ' + sBoId);
                    deferred.resolve([]);
                    return 0;
                }
                var avaliablePrintReports = response['data']['data'];
                deferred.resolve(avaliablePrintReports);
            }
        });
    }

    return deferred.promise;
}

/**
 * Retourne une liste HTML contenant les rapports
 * @param  {array} aPrintReports liste des rapports
 * @return {dom} Liste au format HTML
 */
var getReportsListAsHTML = function(aPrintReports) {

    if (!aPrintReports.length > 0) {
        return 'Aucun rapport disponible';
    }

    var domLi;
    var sHTMLLi;
    var domUl = $(document.createElement('ul')).addClass('anc_saisie_controle_rapports_list');
    for (var i = 0; i < aPrintReports.length; i++) {

        sHTMLLi = '<li>';
        sHTMLLi += '<a href="javascript:void(0)" class="padding-sides-10">';
        sHTMLLi += '<span class="glyphicon glyphicon-download-alt margin-sides-5"></span>';
        sHTMLLi += aPrintReports[i]['name'];
        sHTMLLi += '<span class="margin-sides-5 icon-files-o"></span>';
        sHTMLLi += '</a>';
        sHTMLLi += '</li>';
        domLi = $(sHTMLLi);

        $(domLi).click(angular.bind(this, generateReport, aPrintReports[i]));
        $(domUl).append($(domLi));
    }

    return domUl;
}

/**
 * Génère le rapport vMap correspondant
 *
 * @param  {object} oPrintReport Définition du rapport
 */
var generateReport = function(oPrintReport) {

    if (angular.isDefined(oVmap.generatePrintReport)) {
        oVmap.generatePrintReport({
            'printReportId': oPrintReport['printreport_id'],
            'ids': [envSrvc['sId']]
        });
    } else {
        var sMessage = 'Module vMap requis pour effectuer cette opération';
        console.error(sMessage);
        $.notify(sMessage, 'error');
    }
}
